/* kcom-console-terminal.cc */
/* Created by Enomoto Sanshiro on 26 April 2000. */
/* Last updated by Enomoto Sanshiro on 26 April 2000. */


#include <cstdlib>
#include <iostream>
#include "KcomTerminal.hh"
#include "KcomConsoleTerminal.hh"

using namespace std;


int main(int argc, char **argv)
{
#if 0
    for (int i = 0; i < argc; i++) {
	cerr << "  [" << i << "] " << argv[i] << endl;
    }
#endif

    if (argc  < 2) {
	cerr << "ERROR: " << argv[0] << ": too few arguments" << endl;
	exit(EXIT_FAILURE);
    }
    string Name = argv[1];

    TKcomTerminal* Terminal = new TKcomConsoleTerminal();
    TKcomTerminalServer* TerminalServer = new TKcomTerminalServer(
	Name, Terminal
    );

    try {
	TerminalServer->Start();
    }
    catch (TKcomException &e) {
	cerr << "ERROR: " << argv[0] << ": " << e << endl;
    }

    delete TerminalServer;
    delete Terminal;

    char ch;
    cerr << endl << "---" << endl;
    cerr << "Press <ENTER> to close this window..." << endl;
    cin.get(ch);

    return 0;
}
